var brickem = {

  // html elements
  page: null,
  page_home: null,
  page_game: null,
  game_col: null,
  game_zone: null,
  messages: null,
  overlay: null,
  infos: null,
  next_zone: null,
  best_zone: null,
  score_zone: null,
  lines_zone: null,

  // display (kinetic)
  stage: null,
  next_stage: null,
  layer_stone: null,
  layer_shadow: null,
  layer_block: null,
  next_layer: null,
  block_width: 0,
  block_width_standard: .067,   // divide by 15
  block_height_standard: .056,  // divide by 18
  display_stone: [],
  display_shadow: [],
  display_block: [],
  display_line: [],
  display_next: [],
  shine_tab: [],

  // game infos
  state: null,
  board: [],
  next_block: null,
  next_block_pos: null,
  block: null,
  block_pos: null,
  block_x: 0,
  block_y: 0,
  rows: 19,
  cols: 10,

  // speed
  fall_timeout: null,
  stationary: false,
  init_speed: 600,
  max_speed_mode: false,
  max_speed: 50,
  speed: 0,

  // counters
  level: 0,
  score: 0,
  best_score_brickem: 0,
  best_lines_brickem: 0,
  lines: 0,
  count_single: 0,
  count_double: 0,
  count_triple: 0,
  count_brickem: 0,

  // touch/finger controls
  last_pos_x: 0,
  last_pos_y: 0,
  moving: false,
  time_touch_down: 0,
  finger_lock: false,

  // keyboard controls
  press_left: false,
  press_right: false,
  press_down: false,
  press_drop: false,
  press_rotate: false,
  mappings: {
    '13': 'drop',   // 13 = Enter
    '32': 'drop',   // 32 = Space
    '37': 'left',   // 37 = Left
    '38': 'rotate', // 38 = Up
    '39': 'right',  // 39 = Right
    '40': 'down',   // 40 = Down
    '81': 'left',   // 81 = Q
    '90': 'rotate', // 90 = Z
    '68': 'right',  // 68 = D
    '83': 'down'    // 83 = S
  },
  colors: [
    '#6699ff',//    '#00E4E4',  // line piece	light blue
    '#f2c42d',//    '#E4DE00',  // square piece	yellow
    '#0d49ff',//    '#004EE4',  // J piece		dark blue
    '#ff7d00',//    '#E46200',  // L piece		orange
    '#22a822',//    '#00E427',  // S piece		green
    '#e03b38',//    '#E40027',  // Z piece		red
    '#673092' //    '#9C13E4'   // T piece		purple
  ],
  tab_probability: [1, 1, 1, 1, 1, 1, 1],
  shape: [
    // line piece
    [
      [
        [0,0,0,0],
        [0,0,0,0],
        [1,1,1,1],
        [0,0,0,0]
      ],
      [
        [0,1,0,0],
        [0,1,0,0],
        [0,1,0,0],
        [0,1,0,0]
      ],
      [
        [0,0,0,0],
        [1,1,1,1],
        [0,0,0,0],
        [0,0,0,0]
      ],
      [
        [0,0,1,0],
        [0,0,1,0],
        [0,0,1,0],
        [0,0,1,0]
      ]
    ],
    // square piece
    [
      [
        [1,1],
        [1,1]
      ]
    ],
    // J piece
    [
      [
        [0,0,0],
        [1,1,1],
        [0,0,1]
      ],
      [
        [0,1,0],
        [0,1,0],
        [1,1,0]
      ],
      [
        [1,0,0],
        [1,1,1],
        [0,0,0]
      ],
      [
        [0,1,1],
        [0,1,0],
        [0,1,0]
      ]
    ],
    // L piece
    [
      [
        [0,0,0],
        [1,1,1],
        [1,0,0]
      ],
      [
        [1,1,0],
        [0,1,0],
        [0,1,0]
      ],
      [
        [0,0,1],
        [1,1,1],
        [0,0,0]
      ],
      [
        [0,1,0],
        [0,1,0],
        [0,1,1]
      ]
    ],
    // S piece
    [
      [
        [0,0,0],
        [0,1,1],
        [1,1,0]
      ],
      [
        [1,0,0],
        [1,1,0],
        [0,1,0]
      ],
      [
        [0,1,1],
        [1,1,0],
        [0,0,0]
      ],
      [
        [0,1,0],
        [0,1,1],
        [0,0,1]
      ]
    ],
    // Z piece
    [
      [
        [0,0,0],
        [1,1,0],
        [0,1,1]
      ],
      [
        [0,1,0],
        [1,1,0],
        [1,0,0]
      ],
      [
        [1,1,0],
        [0,1,1],
        [0,0,0]
      ],
      [
        [0,0,1],
        [0,1,1],
        [0,1,0]
      ]
    ],
    // T piece
    [
      [
        [0,0,0],
        [1,1,1],
        [0,1,0]
      ],
      [
        [0,1,0],
        [1,1,0],
        [0,1,0]
      ],
      [
        [0,1,0],
        [1,1,1],
        [0,0,0]
      ],
      [
        [0,1,0],
        [0,1,1],
        [0,1,0]
      ]
    ]
  ],

  init: function () {
	$.mobile.loading('show');
    brickem.page = document.getElementById('contentgamebrickem');
    brickem.page_home = document.getElementById('brickem-home-page');
    brickem.page_game = document.getElementById('brickem-game-page');
    brickem.game_col = document.getElementById('game_col');
    brickem.game_zone = document.getElementById('game_zone');
    brickem.messages = document.getElementById('messages');
    brickem.overlay = document.getElementById('overlay');
    brickem.infos = document.getElementById('infos');
    brickem.next_zone = document.getElementById('next_zone');
    brickem.best_zone = document.getElementById('best_zone');
    brickem.score_zone = document.getElementById('score_zone');
    brickem.lines_zone = document.getElementById('lines_zone');

    //brickem.block_width = parseInt(brickem.page.offsetWidth * brickem.block_width_standard);
	brickem.block_width = brickem.getscreenblockwidth();

    brickem.stage = new Kinetic.Stage({
      container: 'game_zone',
      width: brickem.cols * brickem.block_width,
      height: (brickem.rows - 1) * brickem.block_width
    });
    brickem.layer_stone = new Kinetic.Layer();
    brickem.layer_shadow = new Kinetic.Layer();
    brickem.layer_block = new Kinetic.Layer();
    for (var i = 1; i < brickem.rows; i++) {
      brickem.display_stone[i] = [];
      brickem.display_shadow[i] = [];
      brickem.display_block[i] = [];
      for (var j = 0; j < brickem.cols; j++) {
        brickem.display_stone[i][j] = brickem.create_group(j * brickem.block_width, (i - 1) * brickem.block_width);
        brickem.layer_stone.add(brickem.display_stone[i][j]);
        brickem.display_shadow[i][j] = brickem.create_shadow(j * brickem.block_width, (i - 1) * brickem.block_width);
        brickem.layer_shadow.add(brickem.display_shadow[i][j]);
        brickem.display_block[i][j] = brickem.create_group(j * brickem.block_width, (i - 1) * brickem.block_width);
        brickem.layer_block.add(brickem.display_block[i][j]);
      };
      brickem.display_line[i] = new Kinetic.Rect({
        id: 'sq',
        x: 0,
        y: (i - 1) * brickem.block_width,
        width: brickem.block_width * brickem.cols,
        height: brickem.block_width,
        fill: '#ffffff'
      });
      brickem.display_line[i].hide();
      brickem.layer_block.add(brickem.display_line[i]);
    };
    brickem.stage.add(brickem.layer_stone);
    brickem.stage.add(brickem.layer_shadow);
    brickem.stage.add(brickem.layer_block);
    brickem.layer_stone.draw();
    brickem.layer_shadow.draw();
    brickem.layer_block.draw();
    brickem.next_stage = new Kinetic.Stage({
      container: 'next_zone',
      width: 4 * brickem.block_width,
      height: 4 * brickem.block_width
    });
    brickem.next_layer = new Kinetic.Layer();
    for (var i = 0; i < 4; i++) {
      brickem.display_next[i] = [];
      for (var j = 0; j < 4; j++) {
        brickem.display_next[i][j] = brickem.create_group(j * brickem.block_width, i * brickem.block_width);
        brickem.next_layer.add(brickem.display_next[i][j]);
      };
    };
    brickem.next_stage.add(brickem.next_layer);
    brickem.next_layer.draw();

	//DO NOT EXECUTE A SECOND TIME! ehm, okay for touch; now that removal works normal
	if (brickem.state == null) {
		brickem.watch_keys();
	}
	brickem.watch_touch();
	
	var ua = navigator.userAgent;
	if (ua.indexOf("Windows Phone")>=0) {
		brickem.watch_arrows();
		$('#controls_wrapper').show();
	} else {
		$('#controls_wrapper').hide();
	}
	
    var local_best_score_brickem = localStorage.getItem('best_score_brickem');
    if (local_best_score_brickem != null) {
      brickem.best_score_brickem = local_best_score_brickem;
    }
    //brickem.best_zone.innerHTML = brickem.best_score_brickem;
	$('#best_score_num').html(brickem.best_score_brickem);

    var local_best_lines_brickem = localStorage.getItem('best_lines_brickem');
    if (local_best_lines_brickem != null) {
      brickem.best_lines_brickem = local_best_lines_brickem;
    }
	$('#best_lines_num').html(brickem.best_lines_brickem);

    brickem.resize();
//    window.addEventListener('resize', function() {
//      brickem.resize();
//    });
/*
    document.getElementById('bt_type_a').addEventListener('click', function() {
      brickem.set_mapping('a');
    });
    document.getElementById('bt_type_b').addEventListener('click', function() {
      brickem.set_mapping('b');
    });
*/
    document.getElementById('bt_new_game').addEventListener('click', function(e) {
      e.preventDefault();
      brickem.show_game();
    });

    document.getElementById('bt_pause').addEventListener('click', function(e) {
      e.preventDefault();
      if (brickem.state == 'game') {
        brickem.pause_game();
      } else {
        if (brickem.state == 'pause') {
          brickem.resume_game();
        }
      }
    });

    document.getElementById('leavebrickem').addEventListener('click', function(e) {
//      //e.preventDefault();
//      if (brickem.state == 'game') {
//        brickem.pause_game();
//      }
		brickem.state = 'pause';
		if (typeof brickem.fall_timeout != 'undefined') { clearTimeout(brickem.fall_timeout); }
		brickem.stop_watch_touch();
    });

    // set default mapping
    brickem.set_mapping('a');

//	if (brickem.state != 'pause') {
	brickem.show_game();
//	brickem.show_home();
//	}
	setTimeout(function(){ 
		$.mobile.loading('hide');
	}, 0);
  },

  create_group: function (x, y) {
    var group = new Kinetic.Group({
      x: x,
      y: y
    });
    var square = new Kinetic.Rect({
      id: 'sq',
      x: 0,
      y: 0,
      width: brickem.block_width,
      height: brickem.block_width,
      fill: '#000000'
    });
    var light = new Kinetic.Polygon({
      x: 0,
      y: 0,
      points: [
        0, 0,
        brickem.block_width, 0,
        brickem.block_width * .8, brickem.block_width * .2,
        brickem.block_width * .2, brickem.block_width * .2,
        brickem.block_width * .2, brickem.block_width * .8,
        0, brickem.block_width
      ],
      fill: 'rgba(255, 255, 255, .3)'
    });
    var dark = new Kinetic.Polygon({
      x: 0,
      y: 0,
      points: [
        brickem.block_width, brickem.block_width,
        0, brickem.block_width,
        brickem.block_width * .2, brickem.block_width * .8,
        brickem.block_width * .8, brickem.block_width * .8,
        brickem.block_width * .8, brickem.block_width * .2,
        brickem.block_width, 0
      ],
      fill: 'rgba(0, 0, 0, .3)'
    });
    group.add(square);
    group.add(light);
    group.add(dark);

    return group;
  },

  create_shadow: function (x, y) {
    var square = new Kinetic.Rect({
      id: 'sq',
      x: x,
      y: y,
      opacity : .3,
      width: brickem.block_width,
      height: brickem.block_width,
      fill: '#000000'
    });
    return square;
  },

  show_home: function () {
    brickem.page_home.style.display = 'block';
    brickem.page_game.style.display = 'none';
    brickem.state = 'home';
  },

  show_game: function () {
    brickem.page_home.style.display = 'none';
    brickem.page_game.style.display = 'block';
    brickem.state = 'game';
    brickem.init_game();
  },

  set_mapping: function (type) {
    switch (type) {
      case 'a' :
        brickem.mappings['13'] = 'drop';   // 13 = Enter
        brickem.mappings['32'] = 'drop';   // 32 = Space
        brickem.mappings['38'] = 'rotate'; // 38 = Up
        brickem.mappings['90'] = 'rotate'; // 90 = Z
/*        document.getElementById('bt_type_a').className = 'on';
        document.getElementById('bt_type_a').nextElementSibling.className = 'on';
        document.getElementById('bt_type_b').className = '';
        document.getElementById('bt_type_b').nextElementSibling.className = '';*/
        break;
      case 'b' :
        brickem.mappings['13'] = 'rotate'; // 13 = Enter
        brickem.mappings['32'] = 'rotate'; // 32 = Space
        brickem.mappings['38'] = 'drop';   // 38 = Up
        brickem.mappings['90'] = 'drop';   // 90 = Z
/*        document.getElementById('bt_type_b').className = 'on';
        document.getElementById('bt_type_b').nextElementSibling.className = 'on';
        document.getElementById('bt_type_a').className = '';
        document.getElementById('bt_type_a').nextElementSibling.className = '';*/
        break;
    }
  },

  init_game: function () {

	if (blnADSStarted==true) {
		if (typeof AdMob!="undefined") {
			if (blnADSinterstitialIsReady!=true) {
				AdMob.prepareInterstitial( {adId:strADSadmobid.interstitial, autoShow:false} );
			}
		}
	}
	
    brickem.state = 'game';
    brickem.overlay.style.display = 'none';
    brickem.level = 0;
    brickem.speed = brickem.init_speed;
    brickem.lines = 0;
    //brickem.lines_zone.innerHTML = brickem.lines;
	$('#current_lines_num').html(brickem.lines);
    brickem.score = 0;
    //brickem.score_zone.innerHTML = brickem.score;
	$('#current_score_num').html(brickem.score);
	
    brickem.count_single = 0;
    brickem.count_double = 0;
    brickem.count_triple = 0;
    brickem.count_brickem = 0;
    brickem.clear_board();
    brickem.create_block();

//    setTimeout(function () {
//      // hide the address bar
//      window.scrollTo(0, 1);
//    }, 0);
  },

  clear_board: function () {
    for (var i = 0; i < brickem.rows; i++) {
      brickem.board[i] = [];
      for (var j = 0; j < brickem.cols; j++) {
        brickem.board[i][j] = {
          stone: false,
          block: false,
          shadow: false,
          updated: true,
          color: null
        };
      };
    };
    brickem.show_stone();
  },

  get_random_block: function () {
    // find random number according to probability
    var rand = Math.random()*7;
    var stop = 0;
    rand -= brickem.tab_probability[stop];
    while (rand > 0) {
      stop++;
      if (stop > 6) {
        break;
      };
      rand -= brickem.tab_probability[stop];
    }
    // redistribute probability
    var to_distribute = brickem.tab_probability[stop] * .5;
    brickem.tab_probability[stop] *=  .5;
    for (var j = 0; j < 7; j++) {
      if (j != stop) {
        brickem.tab_probability[j] += to_distribute / 6;
      };
    }
    return stop;
  },

  create_next_block: function () {
    brickem.next_block = brickem.get_random_block();
    brickem.next_block_pos = Math.floor(Math.random()*brickem.shape[brickem.next_block].length);
    brickem.show_next();
  },

  create_block: function () {

    brickem.max_speed_mode = false;
    if (brickem.block == null || brickem.block_pos == null) {
      brickem.create_next_block();
    };
    brickem.block = brickem.next_block;
    brickem.block_pos = brickem.next_block_pos;

    brickem.create_next_block();

    brickem.block_x = 3;
    brickem.block_y = 0;

    while (!brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x, brickem.block_y)) {
      brickem.block_y--;
    };


    brickem.update_block();

    brickem.fall_timeout = setTimeout(function(){
      brickem.fall_block();
    }, brickem.max_speed_mode ? brickem.max_speed : brickem.speed);

  },

  lock_block: function () {
    clearTimeout(brickem.fall_timeout);
    brickem.finger_lock = true;

    // turn moving block into stone
    for (var i = 0; i < brickem.rows; i++) {
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[i][j].block) {
          brickem.board[i][j].block = false;
          brickem.board[i][j].stone = true;
          brickem.board[i][j].updated = true;
          brickem.shine_tab.push({
            i: i,
            j: j
          });

        };
      }
    }

    brickem.shine();

    // check for line creation
    var lines_found = []
    for (var i = brickem.rows-1; i >= 0; i--) {
      var num_blocks = 0;
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[i][j].stone) {
          num_blocks++;
        };
      };
      if (num_blocks == brickem.cols) {
        lines_found.push(i);
        brickem.lit_line(i);
      };
    };

    brickem.show_stone();

    if (lines_found.length == 0) {
      // check for overflowing (game over)
      var game_over = false;
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[0][j].stone) {
          game_over = true;
          break;
        };
      };
      if (game_over) {
        brickem.game_over();
      } else {
        brickem.create_block();
      };
    } else {
      brickem.state = 'pause';
      // erase lines and fall blocks
      // add lines to counter
      brickem.lines += lines_found.length;
      //brickem.lines_zone.innerHTML = brickem.lines;
		$('#current_lines_num').html(brickem.lines);
      // adjust speed
      brickem.level = Math.floor(brickem.lines / 10);
      brickem.speed = brickem.init_speed - brickem.level * 50;
      if (brickem.speed < 100) {
        // maximum difficulty
        brickem.speed = 100;
      };
      // add points to counter
      switch (lines_found.length) {
        case 1 :
          brickem.count_single++;
          brickem.score += 40;
          break;
        case 2 :
          brickem.count_double++;
          brickem.score += 100;
          brickem.message('Double');
          break;
        case 3 :
          brickem.count_triple++;
          brickem.score += 300;
          brickem.message('Triple');
          break;
        case 4 :
          brickem.count_brickem++;
          brickem.score += 1200;
          brickem.message('brickem');
          break;
      };
      //brickem.score_zone.innerHTML = brickem.score;
		$('#current_score_num').html(brickem.score);

      setTimeout(function(){
        // fall blocks
        var hole = 0;
        for (var i = brickem.rows-1; i >= 0; i--) {
          var hole_found = false;
          for (var k = 0; k < lines_found.length; k++) {
            if (lines_found[k] == i-hole) {
              hole_found = true;
            };
          }
          while (hole_found) {
            hole++;
            hole_found = false;
            for (var k = 0; k < lines_found.length; k++) {
              if (lines_found[k] == i-hole) {
                hole_found = true;
              };
            }
          };
          // copy line
          for (var j = 0; j < brickem.cols; j++) {
            if (i-hole >= 0) {
              brickem.board[i][j].stone = brickem.board[i-hole][j].stone;
              brickem.board[i][j].block = brickem.board[i-hole][j].block;
              brickem.board[i][j].shadow = brickem.board[i-hole][j].shadow;
              brickem.board[i][j].color = brickem.board[i-hole][j].color;
              brickem.board[i][j].updated = true;
            } else {
              brickem.board[i][j].stone = false;
              brickem.board[i][j].block = false;
              brickem.board[i][j].shadow = false;
              brickem.board[i][j].color = null;
              brickem.board[i][j].updated = true;
            };
          };
        };
        brickem.show_stone();
        brickem.state = 'game';
        brickem.create_block();
      }, 300);
    };
  },

  pause_game: function () {
    brickem.state = 'pause';
    clearTimeout(brickem.fall_timeout);
    var html = '<h2>Game paused</h2>';
    html += '<a class="button" id="bt_resume">Resume</a>';
    html += '<a class="button" id="bt_play_again">New game</a>';
//    html += '<a class="button" id="bt_main_menu">Main menu</a>';
    html += '<a class="button" href="index.html">More games</a>';
    brickem.overlay.innerHTML = html;
    brickem.overlay.style.display = 'block';

    document.getElementById('bt_resume').addEventListener('click', function() {
      brickem.resume_game();
    });
    document.getElementById('bt_play_again').addEventListener('click', function() {
      brickem.init_game();
    });
//    document.getElementById('bt_main_menu').addEventListener('click', function() {
//      brickem.show_home();
//    });
  },

  resume_game: function () {
    brickem.state = 'game';
    brickem.fall_block();
    brickem.overlay.style.display = 'none';
  },

  game_over: function () {
    brickem.state = 'game_over';

    if (brickem.score > brickem.best_score_brickem) {
      brickem.best_score_brickem = brickem.score;
      localStorage.setItem('best_score_brickem', brickem.best_score_brickem);
      //brickem.best_zone.innerHTML = brickem.best_score_brickem;
		$('#best_score_num').html(brickem.best_score_brickem);
    }
    if (brickem.lines > brickem.best_lines_brickem) {
      brickem.best_lines_brickem = brickem.lines;
      localStorage.setItem('best_lines_brickem', brickem.best_lines_brickem);
		$('#best_lines_num').html(brickem.best_lines_brickem);
    }

    var html = '<h2>Game Over</h2>';
    html += '<div class="overview">';
    html += '<div class="points"><div class="nb_points">' + brickem.score + '</div> points</div>';
    html += '<div class="lines"><div class="nb_lines">' + brickem.lines + '</div> lines</div>';
    html += '</div>';
    html += '<a class="button" id="bt_play_again">Play again</a>';
//    html += '<a class="button" id="bt_main_menu">Main menu</a>';
    html += '<a class="button" href="index.html">More games</a>';
    brickem.overlay.innerHTML = html;
    brickem.overlay.style.display = 'block';

    document.getElementById('bt_play_again').addEventListener('click', function() {
      brickem.init_game();
    });
//    document.getElementById('bt_main_menu').addEventListener('click', function() {
//      brickem.show_home();
//    });

		setTimeout(function(){ 
			if (blnADSinterstitialIsReady==true) {
				blnADSinterstitialIsReady=false;
				AdMob.showInterstitial();
			}
		}, 450);

  },

  fall_block: function () {
    if (brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x, brickem.block_y + 1)) {
      // in the air : move the block down
      brickem.stationary = false;
      brickem.block_y++;
      brickem.update_block();
      if (brickem.max_speed_mode) {
        brickem.score += 1;
        //brickem.score_zone.innerHTML = brickem.score;
		$('#current_score_num').html(brickem.score);
      };
      brickem.fall_timeout = setTimeout(function(){
        brickem.fall_block();
      }, brickem.max_speed_mode ? brickem.max_speed : brickem.speed);
    } else {
      // on the ground
      if (brickem.stationary) {
        // lock the block
        brickem.lock_block();
      } else {
        // moving : lock delay
        brickem.stationary = true;
        brickem.fall_timeout = setTimeout(function(){
          brickem.fall_block();
        }, 300);
      }
    };
  },

  test_position: function (block, pos, x, y) {
    var allowed = true;
    for (var i = 0; i < brickem.shape[block][pos].length; i++) {
      if (allowed) {
        for (var j = 0; j < brickem.shape[block][pos][0].length; j++) {
          // for each block of the new pos ...
          if (brickem.shape[block][pos][i][j] == 1) {
            // ... check if there is room to move
            if (x + j < 0 || x + j >= brickem.cols || y + i >= brickem.rows) {
              // off the wall
              allowed = false;
              break;
            } else {
              if (y + i >= 0) {
                if (brickem.board[y + i][x + j].stone) {
                  // block already exists there
                  allowed = false;
                  break;
                };
              };
            };
          };
        };
      };
    };
    return allowed;
  },

  update_block: function () {
    // erase the previous block
    for (var i = 0; i < brickem.rows; i++) {
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[i][j].block || brickem.board[i][j].shadow) {
          brickem.board[i][j].block = false;
          brickem.board[i][j].shadow = false;
          brickem.board[i][j].updated = true;
        }
      };
    };
    // draw the new position of the block
    for (var i = 0; i < brickem.shape[brickem.block][brickem.block_pos].length; i++) {
      for (var j = 0; j < brickem.shape[brickem.block][brickem.block_pos][0].length; j++) {
        if (brickem.shape[brickem.block][brickem.block_pos][i][j] == 1) {
          if (brickem.block_y + i >= 0) {
            brickem.board[brickem.block_y + i][brickem.block_x + j].block = true;
            brickem.board[brickem.block_y + i][brickem.block_x + j].color = brickem.colors[brickem.block];
            brickem.board[brickem.block_y + i][brickem.block_x + j].updated = true;
          }
        }
      };
    };
    // cast shadow
    var kick_y = 0;
    while (brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x, brickem.block_y + kick_y)) {
      kick_y++;
    }
    for (var i = 0; i < brickem.shape[brickem.block][brickem.block_pos].length; i++) {
      for (var j = 0; j < brickem.shape[brickem.block][brickem.block_pos][0].length; j++) {
        if (brickem.shape[brickem.block][brickem.block_pos][i][j] == 1) {
          if (brickem.block_y + i + (kick_y-1) >= 0) {
            if (brickem.board[brickem.block_y + i + (kick_y-1)][brickem.block_x + j].stone == false) {
              brickem.board[brickem.block_y + i + (kick_y-1)][brickem.block_x + j].shadow = true;
              brickem.board[brickem.block_y + i + (kick_y-1)][brickem.block_x + j].color = brickem.colors[brickem.block];
              brickem.board[brickem.block_y + i + (kick_y-1)][brickem.block_x + j].updated = true;
            };
          };
        };
      };
    };
    brickem.show_block();
  },

  show_stone: function () {
    for (var i = 1; i < brickem.rows; i++) {
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[i][j].color != null) {
          brickem.display_stone[i][j].children[0].setFill(brickem.board[i][j].color);
        };
        if (brickem.board[i][j].stone) {
          brickem.display_stone[i][j].show();
        } else {
          brickem.display_stone[i][j].hide();
        };
      };
    };
    // fix for Android 4.1
    /*
    var canvas = document.querySelectorAll('#game_zone canvas');
    canvas[0].width = brickem.block_width * brickem.cols;
    canvas[0].height = brickem.block_width * (brickem.rows - 1);
    canvas[1].width = brickem.block_width * brickem.cols;
    canvas[1].height = brickem.block_width * (brickem.rows - 1);
    canvas[2].width = brickem.block_width * brickem.cols;
    canvas[2].height = brickem.block_width * (brickem.rows - 1);
    */

    brickem.layer_stone.draw();
  },

  show_block: function () {
    for (var i = 1; i < brickem.rows; i++) {
      for (var j = 0; j < brickem.cols; j++) {
        if (brickem.board[i][j].updated) {
          if (brickem.board[i][j].block) {
            brickem.display_block[i][j].children[0].setFill(brickem.board[i][j].color);
            brickem.display_block[i][j].show();
          } else {
            brickem.display_block[i][j].hide();
          };
          if (brickem.board[i][j].shadow) {
            brickem.display_shadow[i][j].setFill(brickem.board[i][j].color);
            brickem.display_shadow[i][j].show();
          } else {
            brickem.display_shadow[i][j].hide();
          };
          brickem.board[i][j].updated = false;
        };
      };
    };
    // fix for Android 4.1
    /*
    var canvas = document.querySelectorAll('#game_zone canvas');
    canvas[0].width = brickem.block_width * brickem.cols;
    canvas[0].height = brickem.block_width * (brickem.rows - 1);
    canvas[1].width = brickem.block_width * brickem.cols;
    canvas[1].height = brickem.block_width * (brickem.rows - 1);
    canvas[2].width = brickem.block_width * brickem.cols;
    canvas[2].height = brickem.block_width * (brickem.rows - 1);
    */
    brickem.layer_shadow.draw();
    brickem.layer_block.draw();
  },

  show_next: function () {
    for (var i = 0; i < 4; i++) {
      for (var j = 0; j < 4; j++) {
        brickem.display_next[i][j].hide();
      };
    };
    for (var i = 0; i < brickem.shape[brickem.next_block][brickem.next_block_pos].length; i++) {
      for (var j = 0; j < brickem.shape[brickem.next_block][brickem.next_block_pos][0].length; j++) {
        if (brickem.shape[brickem.next_block][brickem.next_block_pos][i][j] == 1) {
          brickem.display_next[i][j].children[0].setFill(brickem.colors[brickem.next_block]);
          brickem.display_next[i][j].show();
        }
      };
    };
    switch (brickem.next_block) {
      case 0 :
        brickem.next_layer.setX(0);
        brickem.next_layer.setY(0);
        break;
      case 1 :
        brickem.next_layer.setX(brickem.block_width);
        brickem.next_layer.setY(brickem.block_width);
        break;
      default :
        brickem.next_layer.setX(brickem.block_width / 2);
        brickem.next_layer.setY(brickem.block_width / 2);
        break;
    }
    // fix for Android 4.1
    /*
    var canvas = document.querySelectorAll('#next_zone canvas');
    canvas[0].width = brickem.block_width * 4;
    canvas[0].height = brickem.block_width * 4;
    */

    brickem.next_layer.draw();
  },

  shake: function () {
    brickem.layer_stone.setY(brickem.block_width / 16);
    setTimeout(function(){
      brickem.layer_stone.setY(0);
    }, 50);
  },

  shine: function () {
    for (var k = 0; k < brickem.shine_tab.length; k++) {
      if (brickem.shine_tab[k].i > 0) {
        brickem.display_stone[brickem.shine_tab[k].i][brickem.shine_tab[k].j].children[1].setFill('rgba(255, 255, 255, .6)');
        brickem.display_stone[brickem.shine_tab[k].i][brickem.shine_tab[k].j].children[2].setFill('rgba(0, 0, 0, .6)');
      };
    };
    setTimeout(function(){
      for (var k = 0; k < brickem.shine_tab.length; k++) {
        if (brickem.shine_tab[k].i > 0) {
          brickem.display_stone[brickem.shine_tab[k].i][brickem.shine_tab[k].j].children[1].setFill('rgba(255, 255, 255, .3)');
          brickem.display_stone[brickem.shine_tab[k].i][brickem.shine_tab[k].j].children[2].setFill('rgba(0, 0, 0, .3)');
        };
      }
      brickem.shine_tab = [];
      brickem.layer_stone.draw();
    }, 100);
  },

  lit_line: function (line) {
    brickem.display_line[line].show();
    brickem.layer_block.draw();
    setTimeout(function(){
      brickem.display_line[line].hide();
      brickem.layer_block.draw();
    }, 100);
    setTimeout(function(){
      brickem.display_line[line].show();
      brickem.layer_block.draw();
    }, 200);
    setTimeout(function(){
      brickem.display_line[line].hide();
      brickem.layer_block.draw();
    }, 300);
  },

  message: function (texte) {
    brickem.messages.innerHTML = texte;
    setTimeout(function(){
      brickem.messages.innerHTML = '';
    }, 500);
  },

  move_left: function () {
    if (brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x - 1, brickem.block_y)) {
      brickem.block_x--;
      brickem.stationary = false;
      brickem.update_block();
    };
  },

  move_right: function () {
    if (brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x + 1, brickem.block_y)) {
      brickem.block_x++;
      brickem.stationary = false;
      brickem.update_block();
    };
  },

  drop_block: function () {
    var kick_y = 0;
    while (brickem.test_position(brickem.block, brickem.block_pos, brickem.block_x, brickem.block_y + kick_y)) {
      kick_y++;
    }
    brickem.block_y += kick_y - 1;
    brickem.score += kick_y - 1;
    //brickem.score_zone.innerHTML = brickem.score;
	$('#current_score_num').html(brickem.score);
    brickem.update_block();
    brickem.shake();
    brickem.lock_block();
  },

  rotate_block: function () {
    // try the new position
    var kick_x = 0;
    var kick_y = 0;
    var new_pos = brickem.block_pos + 1;
    if (new_pos >= brickem.shape[brickem.block].length) {
      new_pos = 0;
    };
    var allowed = true;
    allowed = brickem.test_position(brickem.block, new_pos, brickem.block_x, brickem.block_y);

    if (!allowed) {
      // try a wall kick on the left
      if (brickem.test_position(brickem.block, new_pos, brickem.block_x - 1, brickem.block_y)) {
        allowed = true;
        kick_x = -1;
      };
    }
    if (!allowed) {
      // try a wall kick on the right
      if (brickem.test_position(brickem.block, new_pos, brickem.block_x + 1, brickem.block_y)) {
        allowed = true;
        kick_x = 1;
      };
    }
    if (!allowed) {
      // try a wall kick on the top
      if (brickem.test_position(brickem.block, new_pos, brickem.block_x, brickem.block_y - 1)) {
        allowed = true;
        kick_y = -1;
      };
    }
    if (!allowed) {
      // try a double wall kick on the left
      if (brickem.test_position(brickem.block, new_pos, brickem.block_x - 2, brickem.block_y)) {
        allowed = true;
        kick_x = -2;
      };
    }
    if (!allowed) {
      // try a double wall kick on the right
      if (brickem.test_position(brickem.block, new_pos, brickem.block_x + 2, brickem.block_y)) {
        allowed = true;
        kick_x = 2;
      };
    }
    if (allowed) {
      // move the block (rotate)
      brickem.block_pos = new_pos;
      brickem.block_x += kick_x;
      brickem.block_y += kick_y;
      brickem.stationary = false;
      brickem.update_block();
    };
  },

  watch_keys: function () {
    document.addEventListener('keydown', function (e) {
      if (brickem.state == 'game' && brickem.mappings[e.keyCode]) {
        e.preventDefault();
        switch (brickem.mappings[e.keyCode]) {
          case 'left' :
            brickem.move_left();
            brickem.press_left = true;
            break;
          case 'right' :
            brickem.move_right();
            brickem.press_right = true;
            break;
          case 'drop' :
            if (!brickem.press_drop) {
              brickem.drop_block();
              brickem.press_drop = true;
            }
            break;
          case 'down' :
            if (!brickem.press_down) {
              brickem.max_speed_mode = true;
              clearTimeout(brickem.fall_timeout);
              brickem.stationary = true;
              brickem.fall_block();
              brickem.press_down = true;
            }
            break;
          case 'rotate' :
            if (!brickem.press_rotate) {
              brickem.rotate_block();
              brickem.press_rotate = true;
            }
            break;
        };
      };
    });
    document.addEventListener('keyup', function (e) {
      if ((brickem.state == 'game' || brickem.state == 'pause') && brickem.mappings[e.keyCode]) {
        e.preventDefault();
        switch (brickem.mappings[e.keyCode]) {
          case 'left' :
            brickem.press_left = false;
            break;
          case 'right' :
            brickem.press_right = false;
            break;
          case 'drop' :
            brickem.press_drop = false;
            break;
          case 'down' :
            brickem.max_speed_mode = false;
            brickem.press_down = false;
            break;
          case 'rotate' :
            brickem.press_rotate = false;
            break;
        }
      }
    });
  },

//brickem.stop_watch_touch();
  stop_watch_touch: function () {
        brickem.moving = false;
        brickem.finger_lock = false;
//		document.body.removeEventListener('touchstart', function(){} );
//		document.body.removeEventListener('touchmove', function(){} );
//		document.body.removeEventListener('touchend', function(){} );
		document.getElementById('brickem-game-page').removeEventListener('touchstart', function(){} );
		document.getElementById('brickem-game-page').removeEventListener('touchmove', function(){} );
		document.getElementById('brickem-game-page').removeEventListener('touchend', function(){} );
//		console.log('brickem touchevents removed');
  },

  watch_arrows: function () {
    document.getElementById('controlsup').addEventListener('click', function(e) {
      e.preventDefault();
      if (brickem.state == 'game') {
		  brickem.rotate_block();
      }
    });
    document.getElementById('controlsleft').addEventListener('click', function(e) {
      e.preventDefault();
      if (brickem.state == 'game') {
            brickem.move_left();
      }
    });
    document.getElementById('controlsdown').addEventListener('click', function(e) {
      e.preventDefault();
      if (brickem.state == 'game') {
            brickem.drop_block();
/*            brickem.max_speed_mode = true;
              clearTimeout(brickem.fall_timeout);
              brickem.stationary = true;
              brickem.fall_block(); */
      }
    });
    document.getElementById('controlsright').addEventListener('click', function(e) {
      e.preventDefault();
      if (brickem.state == 'game') {
            brickem.move_right();
      }
    });

  },
  watch_touch: function () {
//    document.body.addEventListener('touchstart', function (e) {
    document.getElementById('brickem-game-page').addEventListener('touchstart', function (e) {
      if (brickem.state == 'game') {
        brickem.last_pos_x = e.targetTouches[0].pageX;
        brickem.last_pos_y = e.targetTouches[0].pageY;
        brickem.moving = false;
        brickem.finger_lock = false;
      };
    });
//    document.body.addEventListener('touchmove', function (e) {
    document.getElementById('brickem-game-page').addEventListener('touchmove', function (e) {
      // prevent window scrolling
      e.preventDefault();
      if (brickem.state == 'game' && brickem.finger_lock == false) {
        var new_pos_x = e.targetTouches[0].pageX;
        var new_pos_y = e.targetTouches[0].pageY;
        if (new_pos_x - brickem.last_pos_x <= -brickem.block_width) {
          // finger going left
          brickem.last_pos_x = new_pos_x;
          brickem.last_pos_y = new_pos_y;
          brickem.moving = true;
          brickem.max_speed_mode = false;
          brickem.move_left();
        };
        if (new_pos_x - brickem.last_pos_x >= brickem.block_width) {
          // finger going right
          brickem.last_pos_x = new_pos_x;
          brickem.last_pos_y = new_pos_y;
          brickem.moving = true;
          brickem.max_speed_mode = false;
          brickem.move_right();
        };
        if (new_pos_y - brickem.last_pos_y >= brickem.block_width) {
          // finger going down
          brickem.last_pos_x = new_pos_x;
          brickem.last_pos_y = new_pos_y;
          brickem.moving = true;
          brickem.max_speed_mode = true;
          brickem.time_touch_down = (new Date).getTime();
          clearTimeout(brickem.fall_timeout);
          brickem.stationary = true;
          brickem.fall_block();
        };
        if (new_pos_y - brickem.last_pos_y <= -brickem.block_width) {
          // finger going up
          brickem.last_pos_x = new_pos_x;
          brickem.last_pos_y = new_pos_y;
          brickem.moving = true;
          brickem.max_speed_mode = false;
        };

      };
    });
//    document.body.addEventListener('touchend', function (e) {
    document.getElementById('brickem-game-page').addEventListener('touchend', function (e) {
      if (brickem.state == 'game') {
        if (!brickem.moving) {
          brickem.rotate_block();
        } else {
          if (brickem.max_speed_mode) {
            brickem.max_speed_mode = false;
            if ((new Date).getTime() - brickem.time_touch_down < 100) {
              brickem.drop_block();
            };
          };
        };
      };
    });
  },

  resize: function() {
    brickem.block_width = brickem.getscreenblockwidth(); //parseInt(brickem.page.offsetWidth * brickem.block_width_standard);
	if (brickem.game_col != null) {
		brickem.game_col.style.width = brickem.block_width * brickem.cols + 'px';
		brickem.game_col.style.height = brickem.block_width * (brickem.rows - 1) + 'px';
		brickem.next_zone.style.width = brickem.block_width * 4 + 'px';
		brickem.next_zone.style.height = brickem.block_width * 4 + 'px';
		brickem.stage.width = brickem.cols * brickem.block_width;
		brickem.stage.height = (brickem.rows - 1) * brickem.block_width;
		//console.log('resize');
		var canvas = document.querySelectorAll('#game_zone canvas');
		canvas[0].style.width = brickem.block_width * brickem.cols + 'px';
		canvas[0].style.height = brickem.block_width * (brickem.rows - 1) + 'px';
		canvas[1].style.width = brickem.block_width * brickem.cols + 'px';
		canvas[1].style.height = brickem.block_width * (brickem.rows - 1) + 'px';
		canvas[2].style.width = brickem.block_width * brickem.cols + 'px';
		canvas[2].style.height = brickem.block_width * (brickem.rows - 1) + 'px';

	}
  },

  getscreenblockwidth: function() {
	var screenh = $.mobile.getScreenHeight(),
	screenw = $('.ui-page-active').innerWidth(),
	skip = false,
	header = $(".ui-page-active .ui-header").hasClass("ui-header-fixed") ? $(".ui-page-active .ui-header").outerHeight() - 1 : $(".ui-page-active .ui-header").outerHeight(),
	footer = $(".ui-page-active .ui-footer").hasClass("ui-footer-fixed") ? $(".ui-page-active .ui-footer").outerHeight() - 1 : $(".ui-page-active .ui-footer").outerHeight(),
	contentPadding = $(".ui-page-active .ui-content").outerHeight() - $(".ui-page-active .ui-content").height(),
	pagePadding = $(".ui-page-active").outerHeight() - $(".ui-page-active").height();
	if (!$(".ui-page-active .ui-footer").is(':visible')) { footer = 0; }
	if (blnADSStarted==true) {
		if (typeof AdMob!="undefined") {
			//if (blnADSBanner==true) {
				//SMART_BANNER - 32px, or if the screen height of a device is between 400 and 720, an ad height of 50 is used in both orientations; for screen heights greater than 720, a 90 ad height is used.
				footer = (screenh > 719 ? 90 : (screenh < 400 ? 32 : 50));
			//}
		}
	}
	var content = screenh - header - footer - contentPadding;
	var sh = $('#zone_scoret').height();
	var jw = (screenw-24);
	var jh = (content-24)-sh-12;
	var bw = parseInt(jw * brickem.block_width_standard);
	var bh = parseInt(jh * brickem.block_height_standard);
	if (bw>bh) { bw=bh; }
	bw = parseInt(bw)
	return bw;
  }
};
