/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * 'License'); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * 'AS IS' BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */
var app = {
    // Application Constructor
    initialize: function() {
        this.bindEvents();
    },
    // Bind Event Listeners
    //
    // Bind any events that are required on startup. Common events are:
    // 'load', 'deviceready', 'offline', and 'online'.
    bindEvents: function() {
        document.addEventListener('deviceready', this.onDeviceReady, false);
    },
    // deviceready Event Handler
    //
    // The scope of 'this' is the event. In order to call the 'receivedEvent'
    // function, we must explicity call 'app.receivedEvent(...);'
    onDeviceReady: function() {
        app.receivedEvent('deviceready');
    },
    // Update DOM on a Received Event
    receivedEvent: function(id) {
        if (id == 'deviceready') {
			$.mobile.loading('show');
            var move;
            app.munchem();
            //tilt
			if (typeof navigator != "undefined") {
	            if (typeof navigator.accelerometer != "undefined") {
					var ua = navigator.userAgent;
					if (ua.indexOf("Windows Phone")>=0) {
						//value 0-1 && rotated x=y ??? - http://solutions.developer.com/ms/mobile/mobile-application-development/windows-8-apps-for-the-phonegap-developer-motion-and-orientation.html
						watchID = navigator.accelerometer.watchAcceleration(function onSuccess(acceleration) {
							//$('#debugger').html('W: ' + parseFloat(acceleration.x).toFixed(3) + ' ' + parseFloat(acceleration.y).toFixed(3) + ' ' + parseFloat(acceleration.z).toFixed(3) + ' ');
							var move = ""; //make less sensitive, so threshold 2
							if (Math.abs(acceleration.y) > Math.abs(acceleration.x)) {
								if (Math.abs(acceleration.y) > 2) {
									move = acceleration.y < 0 ? 'munchem/up' : 'munchem/down';
								}
							} else {
								if (Math.abs(acceleration.y) > 2) {
									move = acceleration.y < 0 ? 'munchem/right' : 'munchem/left';
								}
							}
							if (move!="") {
								$(document).trigger(move);
							}
						}, function() {
							//alert('onError!');
						}, {frequency: 100});
					} else {
						//value 0-9.8
						watchID = navigator.accelerometer.watchAcceleration(function(acceleration) {
							//$('#debugger').html('A: ' + parseFloat(acceleration.x).toFixed(3) + ' ' + parseFloat(acceleration.y).toFixed(3) + ' ' + parseFloat(acceleration.z).toFixed(3) + ' ');
							var move = "";
							if (Math.abs(acceleration.y) > Math.abs(acceleration.x)) {
								if (Math.abs(acceleration.y) > 1) {
									move = acceleration.y < 0 ? 'munchem/up' : 'munchem/down';
								}
							} else {
								if (Math.abs(acceleration.x) > 1) {
									move = acceleration.x < 0 ? 'munchem/right' : 'munchem/left';
								}
							}
							if (move!="") {
								$(document).trigger(move);
							}
						}, function() {
							//alert('onError!');
						}, {frequency: 50});
					}
				}
			}
			//swipe
		    $(document).on("swipeleft swiperight swipeup swipedown", function( e ) {
				var move = "";
	            if ( e.type === "swipeleft" ) {
					move = 'munchem/left';
	            } else if ( e.type === "swiperight" ) {
					move = 'munchem/right';
	            } else if ( e.type === "swipeup" ) {
					move = 'munchem/up';
	            } else if ( e.type === "swipedown" ) {
					move = 'munchem/down';
	            }
				if (move!="") {
					$(document).trigger(move);
				}
		    });
			
			$.mobile.loading('hide');

			$('#zone_message').live('touchmove mousemove', function (e) {
				// prevent window scrolling
				e.preventDefault();
			});
		}
    },
    munchem: function(){
/* http://thecodeplayer.com/walkthrough/  ***  html5-game-tutorial-make-a-munchem-game-using-html5-canvas-jquery */
        var canvas = $('#munchemcanvas')[0],
            ctx = canvas.getContext('2d'),
            w = $('#munchemcanvas').width(),
            h = $('#munchemcanvas').height(),
            //cw = 10,
			screenw = $('.ui-page-active').innerWidth(),
			jw = (screenw-24),
/* board is 24 blocks */
			cw = parseInt(jw/24),
            d,dpm,
            food,
            score,
            speed,
            munchem_array;
		var best_score_munchem = 0;

		var local_best_score = localStorage.getItem('best_score_munchem');
		if (local_best_score != null) {
			best_score_munchem = local_best_score;
		}
		$('#best_score_num').html(best_score_munchem);

		var playmode_munchem = "original";
		var local_playmode_munchem = localStorage.getItem('playmode_munchem');
		if (local_playmode_munchem != null) {
			playmode_munchem = local_playmode_munchem;
		}
		$('#best_score_num').html(best_score_munchem);

		//$('#playmode').html('<a id="buttonplaymode" href="#" class="ui-link ui-btn ui-btn-icon-notext ui-shadow ui-corner-all ui-icon-star">' + playmode_munchem + '</a>');
		if (playmode_munchem=="original") {
			$("#buttonplaymode").removeClass("ui-btn-active ui-state-persist");
		} else {
			$("#buttonplaymode").addClass("ui-btn-active ui-state-persist");
		}
		$('#buttonplaymode').html(playmode_munchem);
		$('#buttonplaymode').on('click', function() {
			if (playmode_munchem=="original") {
				playmode_munchem="freestyle";
				$("#buttonplaymode").addClass("ui-btn-active ui-state-persist");
			} else {
				playmode_munchem="original";
				$("#buttonplaymode").removeClass("ui-btn-active ui-state-persist");
			}
			localStorage.setItem('playmode_munchem', playmode_munchem);
			$('#buttonplaymode').html(playmode_munchem);
		});
		
		if (typeof window.plugins != "undefined") {
			if (typeof window.plugins.insomnia != "undefined") {
				window.plugins.insomnia.keepAwake();
				//window.plugins.insomnia.allowSleepAgain();
			}
		}
		
        function init() {
			$('#zone_message').html('');
				if (blnADSStarted==true) {
					if (typeof AdMob!="undefined") {
						if (blnADSinterstitialIsReady!=true) {
							AdMob.prepareInterstitial( {adId:strADSadmobid.interstitial, autoShow:false} );
						}
					}
				}
			dpm = 'right';
            d = 'right';
            create_munchem();
            create_food();
            score = 0;
            speed = 120;
            if(typeof game_loop != 'undefined') clearInterval(game_loop);
            game_loop = setInterval(paint, speed);
        }
        init();
        
        function create_munchem() {
            var length = 5;
            munchem_array = [];
            for(var i = length-1; i>=0; i--) {
                munchem_array.push({x: i, y:0});
            }
        }
        
        function create_food() {
            food = {
                x: Math.round(Math.random()*(w-cw)/cw), 
                y: Math.round(Math.random()*(h-cw)/cw), 
            };
        }
        
        function paint() {
            var nx = munchem_array[0].x;
            var ny = munchem_array[0].y;

            if(d == 'right') nx++;
            else if(d == 'left') nx--;
            else if(d == 'up') ny--;
            else if(d == 'down') ny++;

			dpm = '';
			
			if (playmode_munchem!="original") {
				if (nx < 0) { nx = parseInt(w/cw)-1; }
				if (nx >= parseInt(w/cw)) { nx=0; }
				if (ny < 0) { ny = parseInt(h/cw)-1; }
				if (ny >= parseInt(h/cw)) { ny=0; }
			}
 
            //if (nx == -1 || nx == w/cw || ny == -1 || ny == h/cw || check_collision(nx, ny, munchem_array)) {
//            if (nx < 0 || nx >= parseInt(w/cw) || ny < 0 || ny >= parseInt(h/cw) || check_collision(nx, ny, munchem_array)) {
            if ( ((playmode_munchem=="original") && (nx < 0 || nx >= parseInt(w/cw) || ny < 0 || ny >= parseInt(h/cw))) || check_collision(nx, ny, munchem_array)) {

	            if(typeof game_loop != 'undefined') clearInterval(game_loop);
				//best score
				if (score > best_score_munchem) {
					best_score_munchem = score;
					localStorage.setItem('best_score_munchem', best_score_munchem);
					$('#best_score_num').html(best_score_munchem);
				}
                //restart game
				$('#zone_message').html('<div class="bad">GAME OVER</div>');
				$('#zone_message').append('<div class="good">' + score + ' points</div>');
				$('#zone_message').append('<a href="index.html" class="button">More games</a>');
				$('#zone_message').append('<div class="button bt_new_game_munchem">Play again</div>');

				$('.bt_new_game_munchem').on('click', function () {
					// tracking Google Analytics
					//_gaq.push(['_trackEvent', 'Fruit Salad', 'Play again', 'Play again']);
					//console.log('init');
					init();
				});

				setTimeout(function(){ 
					if (blnADSinterstitialIsReady==true) {
						blnADSinterstitialIsReady=false;
						AdMob.showInterstitial();
					}
				}, 450);

				if (typeof window.plugins != "undefined") {
					if (typeof window.plugins.insomnia != "undefined") {
						//window.plugins.insomnia.keepAwake();
						window.plugins.insomnia.allowSleepAgain();
					}
				}

                //init();
                return;
            }
            
            if(nx == food.x && ny == food.y) {
                var tail = {x: nx, y: ny};
                score++;
				playAudioMunchem('munchingnow');
                create_food();
				speed = speed-2
	            if(typeof game_loop != 'undefined') clearInterval(game_loop);
	            game_loop = setInterval(paint, speed);
            }
            else {
                var tail = munchem_array.pop();
                tail.x = nx; tail.y = ny;
            }
            
            munchem_array.unshift(tail);

            //paint
			ctx.fillStyle = '#FFFFFF';
            ctx.fillRect(0, 0, w, h);
            ctx.strokeStyle = '#000000';
            ctx.strokeRect(0, 0, w, h);
            
            for(var i = 0; i < munchem_array.length; i++) {
                var c = munchem_array[i];
                paint_cell(c.x, c.y);
            }
            
            paint_cell(food.x, food.y);
			$('#current_score_num').html(score);
            //var score_text = 'Score: ' + score;
            //ctx.fillText(score_text, 5, h-5);
        }
        
        function paint_cell(x, y) {
            ctx.fillStyle = '#673092';
            ctx.fillRect(x*cw, y*cw, cw, cw);
            ctx.strokeStyle = '#FFFFFF';
            ctx.strokeRect(x*cw, y*cw, cw, cw);
        }
        
        function check_collision(x, y, array) {
            for(var i = 0; i < array.length; i++) {
                if(array[i].x == x && array[i].y == y)
                    return true;
            }
            return false;
        }
        
        $(document).on('munchem/down', function() {
            if (d != 'up') {
				if (dpm !='up') {
					dpm = d;
                	d = 'down';
				}
			}
        });
        $(document).on('munchem/up', function() {
            if (d != 'down')
				if (dpm !='down') {
					dpm = d;
					d = 'up';
				}
        });
        $(document).on('munchem/right', function() {
            if (d != 'left')
				if (dpm !='left') {
					dpm = d;
					d = 'right';
				}
        });
        $(document).on('munchem/left', function() {
            if (d != 'right')
				if (dpm !='right') {
					dpm = d;
					d = 'left';
				}
        });

        $(document).on('munchem/resize', function() {
			w = $('#munchemcanvas').width();
			h = $('#munchemcanvas').height();
			//cw = 10,
			screenw = $('.ui-page-active').innerWidth();
			jw = (screenw-24);
			/* board is 24 blocks */
			cw = parseInt(jw/24);
        });

		//Lets add the keyboard controls now
		$(document).keydown(function(e){
			var key = e.which;
			//We will add another clause to prevent reverse gear
			if(key == "37" && d != "right") {
				if (dpm !='right') {
					dpm = d;
					d = "left";
				}
			} else if(key == "38" && d != "down") {
				if (dpm !='down') {
					dpm = d;
					d = "up";
				}
			} else if(key == "39" && d != "left") {
				if (dpm !='left') {
					dpm = d;
					d = "right";
				}
			} else if(key == "40" && d != "up") {
				if (dpm !='up') {
					dpm = d;
					d = "down";
				}
			}
			//The munchem is now keyboard controllable
		})
    }
};

function playAudioMunchem(id) {
    var audioElement = document.getElementById(id);
    var url = audioElement.getAttribute('src');
	if (typeof Media != 'undefined') {
		var my_media = new Media(url,
			// success callback
			 function () {
				 //console.log("playAudio():Audio Success");
			 },
			// error callback
			 function (err) {
				 //console.log("playAudio():Audio Error: " + err);
			 }
		);
		// Play audio
		my_media.play();
	} else {
		$('#'+id).get(0).play();
	}
}